Subject: Re: [tcpm] comments on draft-kang-tcpm-accurate-data-scheduling-by-server-00

From: Kangjiao <[email-masked]>
Date: Mon, 3 Aug 2020 01:09:45 +0000

Hello Christoph,

Currently we have no pseudo-code example for you. We are planning to implement and test it in our system but I cannot promise the timeline for this development because of some undetermined factors.

Before that, I think we can discuss and clarify all related use cases/requirements to it for further solution and protocol design.

>From our side, adjusting the weights and preferences on the subflows may be not enough to ensure that all traffic is transmitted along the specified network interface as the analysis in previous mails.

Sincerely,
Jiao

-----Original Message-----
From: Christoph Paasch [mailto:[email-masked]] 
Sent: Tuesday, July 28, 2020 12:58 AM
To: Kangjiao <[email-masked]>
Cc: Olivier Bonaventure <[email-masked]>; [email-masked] Extensions <[email-masked]>; Liangqiandeng <[email-masked]>
Subject: Re: [tcpm] comments on draft-kang-tcpm-accurate-data-scheduling-by-server-00

On 07/25/20 - 15:18, Kangjiao wrote:
> The scenarios in this draft are not for traffic handover when 
> encountering network failure. It is applied when one peer has an 
> explicit plan on traffic switching. For example, for network migration 
> or expansion on server, operator wants to adjust the traffic on these networks in advance.
> This is an actual case.
> 
> We think packet scheduler knows on which subflow the next packet will 
> be sent.
> So it may be a good choice to deploy the logic of accurate traffic 
> switching on this component.

I would love to understand more on how one would implement such kind of a logic. Do you have a pseudo-code example? I have a hard time imagining how the scheduling estimates the amount of traffic it would have sent on subflow A and rather sends it on subflow B, because to drive this decision-making it needs an estimate of RTT, congestion-window,... of subflow A which it only can get by actually scheduling traffic on A.

While at a macro-level an operator can do its traffic-engineering and decide what proportion of traffic should be sent on one vs the other path, I don't see how this translates into the same method at the micro-level where scheduling happens on a packet-by-packet basis and is hugely driven by congestion-control and RTT.

Thus, to achieve such traffic-engineering for the operator it looks to me like it translates rather to adjusting the weights and preferences on the subflows.

Thanks,
Christoph

> 
> Sincerely,
> Jiao
> 
> -----Original Message-----
> From: Olivier Bonaventure [mailto:[email-masked]]
> Sent: Friday, July 24, 2020 10:17 PM
> To: Christoph Paasch <cpaasch=[email-masked]>
> Cc: Kangjiao <[email-masked]>; [email-masked] Extensions 
> <[email-masked]>; Liangqiandeng <[email-masked]>
> Subject: Re: [tcpm] comments on 
> draft-kang-tcpm-accurate-data-scheduling-by-server-00
> 
> Hello,
> 
> 
> > >
> > > From my perspective, I think following are two different requirements:
> > >
> > > 1. Making all the traffic towards S2 (for this case, MP_PRIO may 
> > > be
> > > enough)
> > >
> > > 2. Making traffic only from <IP_C1, IP_S1> to the destination 
> > > IP_S2, which means diverting traffic that should be scheduled to 
> > > <IP_C1, IP_S1> to one subflow belonging to the target network 
> > > interface (it is "on-demand scheduling", for this case, MP_PRIO is 
> > > not enough)
> >
> > What is the use-case for such a scheme?
> 
> Understanding the requirements from the applications would really help in this discussion. This could also serve as input for Multipath QUIC where the middlebox problems that are mentioned in the draft do not exist.
> 
> > I don't see how a multipath scheduler could assign the traffic that "would"
> > have been sent to <C1,S1> to a different subflow. Because for that 
> > he would need to know what *would* have been sent on <C1,S1> which 
> > he can only know once he actually sends traffic on that subflow as 
> > that will be driving the congestion-window which will allow to send more (or less) traffic on <C1,S1>.
> 
> Another point that needs to be taken into account is that when client 
> moves, the network conditions change dynamically and the server view 
> might differ from the wireless conditions on the client. In this case, 
> it is difficult for the server to precisely decide where it wants to 
> receive data. See http://multipath-tcp.org/multimob/
> 
> Olivier
> 
> --
> 
> 
> Disclaimer: https://www.tessares.net/mail-disclaimer/
> <https://www.tessares.net/mail-disclaimer/>
> 
>